
package com.guagua.base.util;

import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.guagua.base.BusinessException;

/**
 * 验证数据
 * @author 徐峰
 *
 */

public class Assert {
	static Logger logger = LoggerFactory.getLogger(Assert.class);
	
	/** 表达式必须为true, 否则抛出异常, message 错误信息提示*/
	public static void isTrue(boolean expression, Object... message) {
		if (!expression) {
			throw new BusinessException(Arrays.toString(message));
		}
	}
	
	/** 对象必须为null, 否则抛出异常, message 错误信息提示*/
	public static void isNull(Object object, Object... message) {
		isTrue(object == null, message);
	}

	/** 对象不能为null, 否则抛出异常*/
	public static void notNull(Object object, Object... message) {
		isTrue(object != null, message);
	}

	/** 字符串不能为空, 否则抛出异常*/
	public static void notEmpley(String text, Object... message) {
		isTrue(text != null && !text.isEmpty(), message);
	}
	
//	/**
//	 * textToSearch
//	 * @param textToSearch 不能为空
//	 * @param substring 不能为空
//	 * @param message
//	 */
//	public static void doesNotContain(String textToSearch, String substring, String message) {
//		if (StringUtils.hasLength(textToSearch) && StringUtils.hasLength(substring) &&
//				textToSearch.indexOf(substring) != -1) {
//			throw new BusinessException(message);
//		}
//	}
//
//	public static void doesNotContain(String textToSearch, String substring) {
//		doesNotContain(textToSearch, substring,
//				"[Assertion failed] - this String argument must not contain the substring [" + substring + "]");
//	}
//
//	/** 数组如果不包含元素，抛出异常 */
//	public static void notEmpty(Object[] array, String message) {
//		if (ObjectUtils.isEmpty(array)) {
//			throw new BusinessException(message);
//		}
//	}
//
//	/** 数组如果不包含元素，抛出异常 */
//	public static void notEmpty(Object[] array) {
//		notEmpty(array, "[Assertion failed] - this array must not be empty: it must contain at least 1 element");
//	}
//
//	/** 数组中出现null值，抛出异常 */
//	public static void noNullElements(Object[] array, String message) {
//		if (array != null) {
//			for (int i = 0; i < array.length; i++) {
//				if (array[i] == null) {
//					throw new BusinessException(message);
//				}
//			}
//		}
//	}
//
//	/** 数组中出现null值，抛出异常 */
//	public static void noNullElements(Object[] array) {
//		noNullElements(array, "[Assertion failed] - this array must not contain any null elements");
//	}
//
//	/** 队列如果不包含元素，抛出异常 */
//	public static void notEmpty(Collection<?> collection, String message) {
//		if (CollectionUtils.isEmpty(collection)) {
//			throw new BusinessException(message);
//		}
//	}
//
//	public static void notEmpty(Collection<?> collection) {
//		notEmpty(collection,
//				"[Assertion failed] - this collection must not be empty: it must contain at least 1 element");
//	}
//
//	/** map如果不包含元素，抛出异常 */
//	public static void notEmpty(Map<?, ?> map, String message) {
//		if (CollectionUtils.isEmpty(map)) {
//			throw new BusinessException(message);
//		}
//	}
//
//	/** map如果不包含元素，抛出异常 */
//	public static void notEmpty(Map<?, ?> map) {
//		notEmpty(map, "[Assertion failed] - this map must not be empty; it must contain at least one entry");
//	}
//
//	public static void isInstanceOf(Class<?> clazz, Object obj) {
//		isInstanceOf(clazz, obj, "");
//	}
//
//	public static void isInstanceOf(Class<?> type, Object obj, String message) {
//		notNull(type, "Type to check against must not be null");
//		if (!type.isInstance(obj)) {
//			throw new BusinessException(message +
//					"Object of class [" + (obj != null ? obj.getClass().getName() : "null") +
//					"] must be an instance of " + type);
//		}
//	}
//
//	public static void isAssignable(Class<?> superType, Class<?> subType) {
//		isAssignable(superType, subType, "");
//	}
//
//	public static void isAssignable(Class<?> superType, Class<?> subType, String message) {
//		notNull(superType, "Type to check against must not be null");
//		if (subType == null || !superType.isAssignableFrom(subType)) {
//			throw new BusinessException(message + subType + " is not assignable to " + superType);
//		}
//	}
//
//	/** 正则表达式验证*/
//	public static void regexCheck(String data, String regex, String message) {
//		Pattern pattern = Pattern.compile(regex);
//		Matcher matcher = pattern.matcher(data);
//		boolean isMatched = matcher.matches();
//		if (!isMatched) {
//			throw new BusinessException(message);
//		}
//	}
//	
//	/** 正则表达式验证*/
//	public static void regexCheck(String data, String regex) {
//		Pattern pattern = Pattern.compile(regex);
//		Matcher matcher = pattern.matcher(data);
//		boolean isMatched = matcher.matches();
//		if (!isMatched) {
//			throw new BusinessException("");
//		}
//	}
}
