package com.guagua.base.util;

import java.util.List;
import java.util.Map;


/**
 * 存储http 通讯的应答信息
 * @author 徐峰
 */
public class HttpResponseInfo {

	/** 响应代码 */
	private int code;
	/** 响应代码的附加信息 */
	private String message;
	/** 响应内容 */
	private String content;
	/** 应答包头内容 */
	private Map<String, List<String>> headerFields;

	public Map<String, List<String>> getHeaderFields() {
		return headerFields;
	}

	public void setCode(int code) {
		this.code = code;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public void setContent(String content) {
		this.content = content;
	}

	public int getCode() {
		return code;
	}

	public String getMessage() {
		return message;
	}

	public String getContent() {
		return content;
	}
	
	/**
	 * 得到 http 成功的响应内容（如果code != 200 则抛出错误）
	 * @return
	 */
	public String getSuccessContent() {
		Assert.isTrue(code == 200, "请求失败，错误码：", code, content);
		return content;
	}
	
	@Override
	public String toString() {
		return "httpCode " + code + ", content " + content + ", message " + message + ", headerFields " + headerFields;
	}

	public void setHeaderFields(Map<String, List<String>> headerFields) {
		this.headerFields = headerFields;
	}
}
